function [BALLS,WALLS,POSITIONS,VELOCITIES,VELOCITIES_HALF,ACCELERATIONS,NEIGHBOURS,CONTACTS,FORCES_ON_WALLS,RESULTING_FORCES_ON_WALLS,WALLS_CONTROL,MONITORED_VARIABLES,Detection_Distance,Last_print_length]=Initialize_Sample(Balls_Origin,Walls_Origin,Balls_Sets,Xvertices,Yvertices,Balls,Balls_File,Walls,Walls_File,LAWS,TIME_STEP)
%%% This function initializes all the arrays that are further needed for computations.

balls=[];
positions=[];
for i=1:size(Balls_Origin,1)
    if Balls_Origin{i,1}==1
        Nballs=Balls_Sets{i,1}(1,1);
        Rmin=Balls_Sets{i,1}(1,2);
        Rmax=Balls_Sets{i,1}(1,3);
        Density=Balls_Sets{i,1}(1,4);
        Material=Balls_Sets{i,1}(1,5);
        [Sample]=Sample_In_Container(Xvertices{i,1},Yvertices{i,1},Nballs,Rmin,Rmax);
        Nsample=size(Sample,1);
        NewBalls=Sample(:,1);
        NewBalls(:,2)=Material*ones(Nsample,1);
        NewBalls(:,3)=Density*ones(Nsample,1);
        NewBalls(:,4)=Density*pi*Sample(:,1).^2;
        NewBalls(:,5)=(NewBalls(:,4).*NewBalls(:,1).^2)/2;
        NewPositions=cat(2,Sample(:,2:3),zeros(Nsample,1));
        balls=[balls;NewBalls];
        positions=[positions;NewPositions];
    elseif Balls_Origin{i,1}==2
        NewBalls=zeros(size(Balls{i,1},1),5);
        NewPositions=zeros(size(Balls{i,1},1),3);
        NewBalls(:,1)=Balls{i,1}(:,1);
        NewBalls(:,2)=Balls{i,1}(:,5);
        NewBalls(:,3)=Balls{i,1}(:,4);
        NewBalls(:,4)=Balls{i,1}(:,4)*pi.*Balls{i,1}(:,1).^2;
        NewBalls(:,5)=(NewBalls(:,4).*NewBalls(:,1).^2)/2;
        NewPositions(:,1:2)=Balls{i,1}(:,2:3);
        balls=[balls;NewBalls];
        positions=[positions;NewPositions];
    elseif Balls_Origin{i,1}==3
        load(Balls_File,'BALLS','POSITIONS');
        balls=[balls;BALLS];
        positions=[positions;POSITIONS];
    end
end
BALLS=balls;
POSITIONS=positions;
Nballs=size(BALLS,1);
VELOCITIES=zeros(Nballs,3);
VELOCITIES_HALF=zeros(Nballs,3);
ACCELERATIONS=zeros(Nballs,3);
CONTACTS=[];

if Walls_Origin==1
    Nwalls=size(Walls,1);
    WALLS=zeros(Nwalls,9);
    WALLS(:,1:2)=Walls(:,1:2);
    WALLS(:,5:6)=Walls(:,3:4);
    WALLS(:,9)=Walls(:,5);
elseif Walls_Origin==2
    load(Walls_File,'WALLS');
end

Detection_Distance=0;
for i=1:size(LAWS,1)
    if strcmp(LAWS{i,3},'Cohesion') | strcmp(LAWS{i,3},'Breakage')
        Detection_Distance=max([Detection_Distance,LAWS{i,4}(1,6)]);
    end
end

NEIGHBOURS=cell(size(BALLS,1),1);
for i=1:size(NEIGHBOURS,1)-1
    NEIGHBOURS{i,1}=[i+1:size(NEIGHBOURS,1)]';
end
for i=1:size(NEIGHBOURS,1)
    NEIGHBOURS{i,2}=[1:size(WALLS,1)]';
end
NEIGHBOURS=Update_Neighbours(1,1,1,NEIGHBOURS,POSITIONS,BALLS,WALLS);
CONTACTS=Update_Contacts(CONTACTS,NEIGHBOURS,POSITIONS,VELOCITIES,LAWS,BALLS,WALLS,TIME_STEP,Detection_Distance);
for i=1:size(CONTACTS,1)
    Law=CONTACTS(i,16);
    if strcmp(LAWS{Law,3},'Breakage')
        CONTACTS(i,17)=3;
    end
end

MONITORED_VARIABLES=[];

WALLS_CONTROL=[];
FORCES_ON_WALLS=cell(size(WALLS,1),1);
RESULTING_FORCES_ON_WALLS=zeros(size(WALLS,1),3);

disp([' '])
disp(['Simulation contains ',int2str(size(BALLS,1)),' discs and ',int2str(size(WALLS,1)),' walls.'])

Last_print_length=0;
tic