function [BallsIni]=Sample_In_Container(Xvertices,Yvertices,Nballs,Rmin,Rmax)
%%% This function provides initial positions of balls with
%%% no interpenetration and in the desired container.
%%% BallsIni : [Radius,Xcentre,Ycentre]

Ncount_Max=100000;
WallsIni=zeros(size(Xvertices,2)-1,4);
for i=1:size(WallsIni,1)-1
    WallsIni(i,1)=Xvertices(i);
    WallsIni(i,2)=Yvertices(i);
    WallsIni(i,3)=Xvertices(i+1);
    WallsIni(i,4)=Yvertices(i+1);
end
WallsIni(i+1,1)=Xvertices(i+1);
WallsIni(i+1,2)=Yvertices(i+1);
WallsIni(i+1,3)=Xvertices(1);
WallsIni(i+1,4)=Yvertices(1);

BallsIni=[(Rmax+Rmin)/2,mean(Xvertices),mean(Yvertices)]*(1+rand/10^5);
if Nballs>1
    Flag1=0;
else
    Flag1=1;
end
while Flag1==0
    R=Rmin+(Rmax-Rmin)*rand;
    for Count=1:Ncount_Max
        X=min(Xvertices)+R+(max(Xvertices)-min(Xvertices)-2*R)*rand;
        Y=min(Yvertices)+R+(max(Yvertices)-min(Yvertices)-2*R)*rand;
        if inpolygon(X,Y,Xvertices,Yvertices)==0
            continue
        end
        Flag2=0;
        for i=1:size(BallsIni,1)
            if norm([X-BallsIni(i,2),Y-BallsIni(i,3)])<R+BallsIni(i,1)
                Flag2=1;
                break
            end
        end
        for i=1:size(WallsIni,1)
            Norm=norm(WallsIni(i,1:2)-WallsIni(i,3:4));
            Position=dot([X,Y]-WallsIni(i,1:2),WallsIni(i,3:4)-WallsIni(i,1:2))/Norm;
            Point=WallsIni(i,1:2)+(WallsIni(i,3:4)-WallsIni(i,1:2))/Norm*Position;
            Vector=Point-[X,Y];
            Distance=norm(Vector);
            if Distance<R
                Flag2=1;
                break
            end
        end
        if Flag2==0
            BallsIni=cat(1,BallsIni,[R,X,Y]);
            break
        end
    end
    if Count==Ncount_Max | size(BallsIni,1)>=Nballs
        Flag1=1;
    end
end

Solid_Fraction=sum(pi*BallsIni(:,1).^2)/polyarea(Xvertices,Yvertices);
disp([' '])
disp(['Solid Fraction of the initial packing = ',num2str(Solid_Fraction)])