function NEW_CONTACTS=Update_Contacts(CONTACTS,NEIGHBOURS,POSITIONS,VELOCITIES,LAWS,BALLS,WALLS,TIME_STEP,Detection_Distance);
NEW_CONTACTS=[];
for i=1:size(NEIGHBOURS,1)
    if size(NEIGHBOURS{i,1},1)==0
        continue
    end
    Ball1=i;
    Radius1=BALLS(Ball1,1);
    Position1=POSITIONS(Ball1,1:2);
    Velocity1=VELOCITIES(Ball1,1:2);
    RotVel1=VELOCITIES(Ball1,3);
    Material1=BALLS(Ball1,2);
    for j=1:size(NEIGHBOURS{i,1},1)
        Ball2=NEIGHBOURS{i,1}(j,1);
        Radius2=BALLS(Ball2,1);
        Position2=POSITIONS(Ball2,1:2);
        Velocity2=VELOCITIES(Ball2,1:2);
        RotVel2=VELOCITIES(Ball2,3);
        Material2=BALLS(Ball2,2);
        DeltaN=norm(Position2-Position1)-(Radius1+Radius2);
        if DeltaN<Detection_Distance
            for k=1:size(LAWS,1)
                if LAWS{k,1}==min([Material1,Material2]) & LAWS{k,2}==max([Material1,Material2])
                    Law=k;
                    break
                end
            end
            DeltaT_Previous=0;
            DeltaR_Previous=0;
            Status_Previous=0;
            for k=1:size(CONTACTS,1)
                if CONTACTS(k,1)==Ball1 & CONTACTS(k,2)==Ball2 & CONTACTS(k,3)==1
                    DeltaT_Previous=CONTACTS(k,12);
                    DeltaR_Previous=CONTACTS(k,14);
                    Status_Previous=CONTACTS(k,17);
                    break
                end
            end
            Normal_Vector=(Position2-Position1)/norm(Position2-Position1);
            Tangential_Vector=[-Normal_Vector(2),Normal_Vector(1)];
            Contact_Point1=Position1+Normal_Vector*Radius1;
            Contact_Point2=Position2-Normal_Vector*Radius2;
            Contact_Point=(Contact_Point1+Contact_Point2)/2;
            DeltaN_Prime=dot((Velocity2-Velocity1),Normal_Vector);
            DeltaT_Prime=dot((Velocity2-Velocity1),Tangential_Vector)-(Radius1*RotVel1+Radius2*RotVel2);
            DeltaR_Prime=Radius1*Radius2/(Radius1+Radius2)*(RotVel1-RotVel2);
            DeltaT=DeltaT_Previous+DeltaT_Prime*TIME_STEP;
            DeltaR=DeltaR_Previous+DeltaR_Prime*TIME_STEP;
            New_Contact=cat(2,Ball1,Ball2,1,Contact_Point,Normal_Vector,Tangential_Vector,DeltaN,DeltaN_Prime,DeltaT,DeltaT_Prime,DeltaR,DeltaR_Prime,Law,Status_Previous);
            NEW_CONTACTS=cat(1,NEW_CONTACTS,New_Contact);
        end
    end
end

for i=1:size(NEIGHBOURS,1)
    if size(NEIGHBOURS{i,2},1)==0
        continue
    end
    Ball1=i;
    Radius1=BALLS(Ball1,1);
    Position1=POSITIONS(Ball1,1:2);
    Velocity1=VELOCITIES(Ball1,1:2);
    RotVel1=VELOCITIES(Ball1,3);
    Material1=BALLS(Ball1,2);
    for j=1:size(NEIGHBOURS{i,2},1)
        Wall2=NEIGHBOURS{i,2}(j,1);
        PositionA2=WALLS(Wall2,1:2);
        PositionB2=WALLS(Wall2,5:6);
        VelocityA2=WALLS(Wall2,3:4);
        VelocityB2=WALLS(Wall2,7:8);
        DX=PositionB2(1)-PositionA2(1);
        DY=PositionB2(2)-PositionA2(2);
        DVx=VelocityB2(1)-VelocityA2(1);
        DVy=VelocityB2(2)-VelocityA2(2);
        RotVel2=(DVy*DX-DVx*DY)/(DX^2+DY^2);
        Material2=WALLS(Wall2,9);
        Wall_Length=norm(PositionB2-PositionA2);
        Position_On_Wall=dot(Position1-PositionA2,PositionB2-PositionA2)/(Wall_Length^2);
        if 0<Position_On_Wall & Position_On_Wall<1
            Contact_Point=PositionA2+(PositionB2-PositionA2)*Position_On_Wall;
            Contact_Type=3;
            Normal_Vector=Contact_Point-Position1;
            Normal_Distance=norm(Normal_Vector);
            Normal_Vector=Normal_Vector/Normal_Distance;
        elseif Position_On_Wall<=0
            Contact_Point=PositionA2;
            Contact_Type=1;
            Normal_Distance=norm(PositionA2-Position1);
            Normal_Vector=(PositionA2-Position1)/Normal_Distance;
        elseif 1<=Position_On_Wall
            Contact_Point=PositionB2;
            Contact_Type=2;
            Normal_Distance=norm(PositionB2-Position1);
            Normal_Vector=(PositionB2-Position1)/Normal_Distance;
        end
        DeltaN=Normal_Distance-Radius1;
        if DeltaN<Detection_Distance
            for k=1:size(LAWS,1)
                if LAWS{k,1}==min([Material1,Material2]) & LAWS{k,2}==max([Material1,Material2])
                    Law=k;
                    break
                end
            end
            DeltaT_Previous=0;
            DeltaR_Previous=0;
            Status_Previous=0;
            for k=1:size(CONTACTS,1)
                if CONTACTS(k,1)==Ball1 & CONTACTS(k,2)==Wall2 & CONTACTS(k,3)==2
                    DeltaT_Previous=CONTACTS(k,12);
                    DeltaR_Previous=CONTACTS(k,14);
                    Status_Previous=CONTACTS(k,17);
                    break
                end
            end
            Tangential_Vector=[-Normal_Vector(2),Normal_Vector(1)];
            if Contact_Type==1
                Velocity2=VelocityA2;
            elseif Contact_Type==2
                Velocity2=VelocityB2;
            elseif Contact_Type==3
                Velocity2=VelocityA2*(1-Position_On_Wall)+VelocityB2*Position_On_Wall;
            end
            DeltaN_Prime=dot((Velocity2-Velocity1),Normal_Vector);
            DeltaT_Prime=dot((Velocity2-Velocity1),Tangential_Vector)-(Radius1*RotVel1);
            %%%
                DeltaR_Prime=Radius1*(RotVel1-RotVel2);
            %%%
            DeltaT=DeltaT_Previous+DeltaT_Prime*TIME_STEP;
            DeltaR=DeltaR_Previous+DeltaR_Prime*TIME_STEP;
            New_Contact=cat(2,Ball1,Wall2,2,Contact_Point,Normal_Vector,Tangential_Vector,DeltaN,DeltaN_Prime,DeltaT,DeltaT_Prime,DeltaR,DeltaR_Prime,Law,Status_Previous);
            NEW_CONTACTS=cat(1,NEW_CONTACTS,New_Contact);
        end
    end
end