function [FORCES_ON_BALLS,RESULTING_FORCES_ON_BALLS,FORCES_ON_WALLS,RESULTING_FORCES_ON_WALLS,ACCELERATIONS,CONTACTS]=Update_Forces(CONTACTS,BALLS,WALLS,LAWS,GRAVITY,TIME_STEP)
FORCES_ON_BALLS=cell(size(BALLS,1),1);
RESULTING_FORCES_ON_BALLS=zeros(size(BALLS,1),3);
FORCES_ON_WALLS=cell(size(WALLS,1),1);
RESULTING_FORCES_ON_WALLS=zeros(size(WALLS,1),3);
ACCELERATIONS=zeros(size(BALLS,1),3);

for i=1:size(CONTACTS,1)
    Ball1=CONTACTS(i,1);
    Radius1=BALLS(Ball1,1);
    Contact_Point=CONTACTS(i,4:5);
    Normal_Vector=CONTACTS(i,6:7);
    Tangential_Vector=CONTACTS(i,8:9);
    DeltaN=CONTACTS(i,10);
    DeltaN_Prime=CONTACTS(i,11);
    DeltaT=CONTACTS(i,12);
    DeltaT_Prime=CONTACTS(i,13);
    DeltaR=CONTACTS(i,14);
    DeltaR_Prime=CONTACTS(i,15);
    Law=CONTACTS(i,16);
    Status=CONTACTS(i,17);
    if CONTACTS(i,3)==1
        Ball2=CONTACTS(i,2);
        Radius2=BALLS(Ball2,1);
        Contact_Radius=Radius1*Radius2/(Radius1+Radius2);
        Effective_Mass=BALLS(Ball1,4)*BALLS(Ball2,4)/(BALLS(Ball1,4)+BALLS(Ball2,4));
        [Normal_Force,Tangential_Force,Torque,DeltaT,DeltaR,Status]=Apply_Contact_Laws(DeltaN,DeltaN_Prime,DeltaT,DeltaT_Prime,DeltaR,DeltaR_Prime,Contact_Radius,Effective_Mass,Law,Status,LAWS,TIME_STEP);
        CONTACTS(i,12)=DeltaT;
        CONTACTS(i,14)=DeltaR;
        CONTACTS(i,17)=Status;
        Force_On_Ball1=-Normal_Force*Normal_Vector-Tangential_Force*Tangential_Vector;
        New_Force1=cat(2,Ball2,1,Contact_Point,Force_On_Ball1,-Tangential_Force*Radius1+Torque,Normal_Force,Tangential_Force);
        FORCES_ON_BALLS{Ball1,1}=cat(1,FORCES_ON_BALLS{Ball1,1},New_Force1);
        Force_On_Ball2=-Force_On_Ball1;
        New_Force2=cat(2,Ball1,1,Contact_Point,Force_On_Ball2,-Tangential_Force*Radius2+Torque,-Normal_Force,-Tangential_Force);
        FORCES_ON_BALLS{Ball2,1}=cat(1,FORCES_ON_BALLS{Ball2,1},New_Force2);
    elseif CONTACTS(i,3)==2
        Wall2=CONTACTS(i,2);
        Contact_Radius=Radius1;
        Effective_Mass=BALLS(Ball1,4);
        [Normal_Force,Tangential_Force,Torque,DeltaT,DeltaR,Status]=Apply_Contact_Laws(DeltaN,DeltaN_Prime,DeltaT,DeltaT_Prime,DeltaR,DeltaR_Prime,Contact_Radius,Effective_Mass,Law,Status,LAWS,TIME_STEP);
        CONTACTS(i,12)=DeltaT;
        CONTACTS(i,14)=DeltaR;
        CONTACTS(i,17)=Status;
        Force_On_Ball1=-Normal_Force*Normal_Vector-Tangential_Force*Tangential_Vector;
        New_Force1=cat(2,Wall2,2,Contact_Point,Force_On_Ball1,-Tangential_Force*Radius1+Torque,Normal_Force,Tangential_Force);
        FORCES_ON_BALLS{Ball1,1}=cat(1,FORCES_ON_BALLS{Ball1,1},New_Force1);
        Force_On_Wall2=-Force_On_Ball1;
        New_Force2=cat(2,Ball1,1,Contact_Point,Force_On_Wall2,Torque,-Normal_Force,-Tangential_Force);
        FORCES_ON_WALLS{Wall2,1}=cat(1,FORCES_ON_WALLS{Wall2,1},New_Force2);
    end
end

RESULTING_FORCES_ON_BALLS(:,1)=BALLS(:,4)*GRAVITY(1);
RESULTING_FORCES_ON_BALLS(:,2)=BALLS(:,4)*GRAVITY(2);
for i=1:size(FORCES_ON_BALLS,1)
    if size(FORCES_ON_BALLS{i,1},1)==0
        continue
    end
    for j=1:size(FORCES_ON_BALLS{i,1},1)
        Fx=FORCES_ON_BALLS{i,1}(j,5);
        Fy=FORCES_ON_BALLS{i,1}(j,6);
        Cz=FORCES_ON_BALLS{i,1}(j,7);
        RESULTING_FORCES_ON_BALLS(i,:)=RESULTING_FORCES_ON_BALLS(i,:)+[Fx,Fy,Cz];
    end
end
ACCELERATIONS(:,1)=RESULTING_FORCES_ON_BALLS(:,1)./BALLS(:,4);
ACCELERATIONS(:,2)=RESULTING_FORCES_ON_BALLS(:,2)./BALLS(:,4);
ACCELERATIONS(:,3)=RESULTING_FORCES_ON_BALLS(:,3)./BALLS(:,5);

for i=1:size(FORCES_ON_WALLS,1)
    if size(FORCES_ON_WALLS{i,1},1)==0
        continue
    end
    Centre=(WALLS(i,1:2)+WALLS(i,5:6))/2;
    for j=1:size(FORCES_ON_WALLS{i,1},1)
        Fx=FORCES_ON_WALLS{i,1}(j,5);
        Fy=FORCES_ON_WALLS{i,1}(j,6);
        Cz=FORCES_ON_WALLS{i,1}(j,7)+Fx*(FORCES_ON_WALLS{i,1}(j,3)-Centre(1))+Fy*(FORCES_ON_WALLS{i,1}(j,4)-Centre(2));
        RESULTING_FORCES_ON_WALLS(i,:)=RESULTING_FORCES_ON_WALLS(i,:)+[Fx,Fy,Cz];
    end
end