function [WallPlot,BallPlot,BrotPlot,NetworkPlot]=Update_Plot(BALLS,WALLS,POSITIONS,VELOCITIES,FORCES_ON_BALLS,COUNT,TIME,Plot_Parameters,WallPlot,BallPlot,BrotPlot,NetworkPlot,Period_Plot)
if COUNT/Period_Plot~=floor(COUNT/Period_Plot)
    return
end
Plot_Type=Plot_Parameters(1,1);
Rotation_Marker=Plot_Parameters(1,2);
Colored_Quantity_Discs=Plot_Parameters(1,3);
Minimum_Color_Discs=Plot_Parameters(1,4);
Maximum_Color_Discs=Plot_Parameters(1,5);
Colored_Quantity_Contacts=Plot_Parameters(1,6);
Minimum_Color_Contacts=Plot_Parameters(1,7);
Maximum_Color_Contacts=Plot_Parameters(1,8);
Plot_Axes=Plot_Parameters(1,9:12);
Maximum_Line_Width=Plot_Parameters(1,14);

for i=1:size(WALLS,1)
    set(WallPlot(i,1),'Xdata',[WALLS(i,1),WALLS(i,5)],'Ydata',[WALLS(i,2),WALLS(i,6)]);
end
Angles=[0:10:360]'/180*pi;
Circle=cat(2,cos(Angles),sin(Angles));

for i=1:size(BALLS,1)
    if Plot_Type==2 | Plot_Type==4
        set(BallPlot(i,1),'Xdata',POSITIONS(i,1)+BALLS(i,1)*Circle(:,1),'Ydata',POSITIONS(i,2)+BALLS(i,1)*Circle(:,2));
        if Colored_Quantity_Discs==1
            V=norm(VELOCITIES(i,1:2));
            C=Translate_Color(V,Minimum_Color_Discs,Maximum_Color_Discs);
        elseif Colored_Quantity_Discs==2
            V=VELOCITIES(i,3);
            C=Translate_Color(V,Minimum_Color_Discs,Maximum_Color_Discs);
        elseif Colored_Quantity_Discs==3
            V=BALLS(i,1);
            C=Translate_Color(V,Minimum_Color_Discs,Maximum_Color_Discs);
        elseif Colored_Quantity_Discs==4
            V=i;
            C=Translate_Color(V,Minimum_Color_Discs,Maximum_Color_Discs);
        elseif Colored_Quantity_Discs==0
            C=[0.7,0.7,0.7];
        end
        set(BallPlot(i,1),'FaceColor',C);
    elseif Plot_Type==1 | Plot_Type==3
        set(BallPlot(i,1),'Xdata',POSITIONS(i,1)+BALLS(i,1)*Circle(:,1),'Ydata',POSITIONS(i,2)+BALLS(i,1)*Circle(:,2));
    end
    if Rotation_Marker==1
        set(BrotPlot(i,1),'Xdata',[POSITIONS(i,1),POSITIONS(i,1)+BALLS(i,1)*cos(POSITIONS(i,3))],'Ydata',[POSITIONS(i,2),POSITIONS(i,2)+BALLS(i,1)*sin(POSITIONS(i,3))]);
    end
end

Nforces=0;
for i=1:size(FORCES_ON_BALLS,1)
    Nforces=Nforces+size(FORCES_ON_BALLS{i,1},1);
end
if (Plot_Type==3 | Plot_Type==4) & Nforces>0
    if size(NetworkPlot,1)>0
        for i=1:size(NetworkPlot,1)
            delete(NetworkPlot(i,1))
        end
    end
    NetworkPlot=zeros(Nforces,1);
    Iforce=0;
    for i=1:size(FORCES_ON_BALLS,1)
        if size(FORCES_ON_BALLS{i,1},1)>0
            for j=1:size(FORCES_ON_BALLS{i,1},1)
                Iforce=Iforce+1;
                X1=POSITIONS(i,1);
                Y1=POSITIONS(i,2);
                X2=FORCES_ON_BALLS{i,1}(j,3);
                Y2=FORCES_ON_BALLS{i,1}(j,4);
                NetworkPlot(Iforce,1)=plot([X1,X2],[Y1,Y2],'-');
                if Colored_Quantity_Contacts==1
                    V=norm(FORCES_ON_BALLS{i,1}(j,5:6));
                    C=Translate_Color(V,Minimum_Color_Contacts,Maximum_Color_Contacts);
                elseif Colored_Quantity_Contacts==0
                    V=norm(FORCES_ON_BALLS{i,1}(j,5:6));
                    C=[0.3,0.3,0.3];
                end
                if V<Minimum_Color_Contacts
                    W=0.01;
                elseif V>Maximum_Color_Contacts
                    W=Maximum_Line_Width;
                else
                    W=0.01+(V-Minimum_Color_Contacts)/(Maximum_Color_Contacts-Minimum_Color_Contacts)*Maximum_Line_Width;
                end
                set(NetworkPlot(Iforce,1),'Color',C,'LineWidth',W);
            end
        end
    end
end
title(['t=',num2str(TIME,'%2.4f')]);
drawnow; 