%%% Choose the simulation directory %%%
Directory='Demo';

%%% Restart an existing simulation ? %%%
Restart_Simulation=1; % 1->New simulation ; 2->From loaded file
Restarting_File='Demo/Simulation0.mat';

%%% Create balls %%%
Balls_Origin={1;...
              2;...
              }; % 1->From generator ; 2->By hand ; 3->From loaded file
          
Balls_Sets={[5,0.2,0.2,2700,1];...
            [];...
            }; % Accounted for if the corresponding line in Balls_Origin is 1
        
Xvertices={[0,2,2,0,0];...
           [];...
           }; % Accounted for if the corresponding line in Balls_Origin is 1
       
Yvertices={[0,0,1,1,0];...
           [];...
           }; % Accounted for if the corresponding line in Balls_Origin is 1
       
Balls={[];...
       [1,-6,8,2700,1];...
       }; % Accounted for if the corresponding line in Balls_Origin is 2
   
Balls_File={[];...
            'file_containing_balls.mat';...
            }; % Accounted for if the corresponding line in Balls_Origin is 3

%%% Create walls %%%
Walls_Origin=1; % 1->By hand ; 2->From loaded file
Walls=[-10,-10,10,-10,2;...
    10,-10,10,10,2;...
    10,10,-10,10,2;...
    -10,10,-10,-10,2;...
    -10,8,-5,3,2;...
    ];
Walls_File='file_containing_walls.mat';

%%% Choose the physics of the simulation %%%
LAWS={[1],[1],['Standard'],[1e8,1e8,0.3,1];...
    [1],[2],['Standard'],[1e8,1e8,0.3,1]};
GRAVITY=[0,-10];

%%% Choose the numerical parameters %%%
Time_ini=0;
Time_fin=20;
TIME_STEP=0.0001;
Neighbours_Parameter=1;
Period_Neighbours=500;
Period_Monitoring=500;
Period_Save=500;

%%% Choose the display options %%%
Display_Time_Step=0;
Period_Plot=500;
Period_Print=500;
Plot_Type=2;
Rotation_Marker=1;
Colored_Quantity_Discs=1;
Discs_Quantity_Range=[0,20];
Colored_Quantity_Contacts=1;
Contacts_Quantity_Range=[0,1000];
Maximum_Line_Width=4;
Plot_Axes=[-10,10,-10,10];
Print_Resolution=150;

%%% Additional controls %%%
%
% You may impose some motion to the walls
%     -> User_Update_Walls.mat
% You may impose some initial conditions
%     -> User Initial Conditions.mat
% You may choose what data to monitor during simulation
%     -> User Monitoring.mat
%
% When done, just launch DEMLAB.mat